#ifndef SIMPLE_PIPELINE_H
#define SIMPLE_PIPELINE_H

#include <stdint.h>
#include <stddef.h>
#include <freertos/FreeRTOS.h>
#include <freertos/task.h>

typedef struct recorder_pipeline_t {
    TaskHandle_t task;
    int src_rate;
    int dest_rate;
    int channels;
    int block_bytes;
} recorder_pipeline_t, *recorder_pipeline_handle_t;

typedef struct player_pipeline_t {
    TaskHandle_t task;
    int src_rate;
    int dest_rate;
    int channels;
    int block_bytes;
    int fade_total;
    int fade_done;
} player_pipeline_t, *player_pipeline_handle_t;

recorder_pipeline_handle_t recorder_pipeline_open();
void recorder_pipeline_run(recorder_pipeline_handle_t);
void recorder_pipeline_close(recorder_pipeline_handle_t);
int recorder_pipeline_get_default_read_size(recorder_pipeline_handle_t);
int recorder_pipeline_read(recorder_pipeline_handle_t, char *buffer, int buf_size);

player_pipeline_handle_t player_pipeline_open();
void player_pipeline_run(player_pipeline_handle_t);
void player_pipeline_close(player_pipeline_handle_t);
int player_pipeline_get_default_read_size(player_pipeline_handle_t);
int player_pipeline_write(player_pipeline_handle_t, char *buffer, int buf_size);
void player_pipeline_write_play_buffer_flag(player_pipeline_handle_t);
void player_pipeline_set_src_rate(player_pipeline_handle_t, int rate);

#endif
